/*
 * gen2shp  - shape import
 * uses a modified/or unmodified  arc generate file
 * sol katz Oct 1997, skatz@blm.gov
 *
 */

#include "shapefil.h"
#include <string.h>  /* pc dos */
#include <stdlib.h>  /* pc dos */

int main( int argc, char ** argv )

{
    SHPHandle	hSHP;
    int		nShapeType, nVertices, nParts, *panParts, i;
    int         nShapeType2,  nEntities;
    double	*padVertices; 
/*    double      *padVertices [2000];*/
    FILE        *ascii_ptr;
    int         j=0, xx=0; 
    char        *eof ;
    long float  coord;
    char        charcoord [81];
    long int    shapeId ;
    char        *txtptr;

/* -------------------------------------------------------------------- */
/*      Display a usage message.                                        */
/* -------------------------------------------------------------------- */
    if( argc < 4 )
    {
	printf( 
"Usage: gen2shp shp_file ascii_coordinate_file [point|arc|polygon|multipoint]\n" );
        printf( "Coordinates are separated by a comma or space \n");
        printf( 
"Islands and \"sybling\" polygons/arcs are separated by \"BREAK\" \n");
        printf( "Unrelated polygons/arcs are separated \"END\"  \n\n");
        printf( "gen to shape import, another GIS translation tool by\n");
        printf( "Sol Katz,skatz@blm.gov, 303-236-0101, Oct 1997\n");
	exit( 1 );
    }

/* -------------------------------------------------------------------- */
/*	Figure out the shape type.					*/
/* -------------------------------------------------------------------- */
    if( strcmp(argv[3],"POINT") == 0 || strcmp(argv[3],"point") == 0 )
        nShapeType = SHPT_POINT;
    else if( strcmp(argv[3],"ARC") == 0 || strcmp(argv[3],"arc") == 0 )
        nShapeType = SHPT_ARC;
    else if( strcmp(argv[3],"POLYGON") == 0 || strcmp(argv[3],"polygon") == 0 )
        nShapeType = SHPT_POLYGON;
    else if( strcmp(argv[3],"MULTIPOINT")==0 ||strcmp(argv[3],"multipoint")==0)
        nShapeType = SHPT_MULTIPOINT;
    else
    {
	printf( "Shape Type `%s' not recognised.\n", argv[3] );
	exit( 2 );
    }
    nShapeType2 = nShapeType; 

/* -------------------------------------------------------------------- */
/*      Open the passed shapefile.                                      */
/* -------------------------------------------------------------------- */
    hSHP = SHPOpen( argv[1], "rb+" );

    if( hSHP == NULL ) /* does not yet exist */
    {

/* -------------------------------------------------------------------- */
/*	Create the requested layer, if doesn't exist .			*/
/* -------------------------------------------------------------------- */
	hSHP = SHPCreate( argv[1], nShapeType );

	if( hSHP == NULL )
	{
		printf( "Unable to create:%s\n", argv[1] );
		exit( 3 );
	}

	else /* good create */

	{
        
		SHPClose( hSHP );
		hSHP = SHPOpen( argv[1], "rb+" );
		if( hSHP == NULL )
		{
			printf( "Unable to open shape file: %s\n", argv[1] );
			printf( "after  creating it\n");
			exit( 1 );
		}
	}
    }

/* -------------------------------------------------------------------- */
/*	Check if the feature type match.				*/
/* -------------------------------------------------------------------- */

    SHPGetInfo( hSHP, &nEntities, &nShapeType );

    if (nShapeType != nShapeType2) 
    {
      if (nShapeType == SHPT_POINT )
        printf (" This is an existing POINT shapefile. \n"); 
      else if (nShapeType == SHPT_ARC )
        printf (" This is an existing ARC shapefile. \n"); 
      else if (nShapeType == SHPT_POLYGON )
        printf (" This is an existing POLYGON shapefile. \n"); 
      else if (nShapeType == SHPT_MULTIPOINT )
        printf (" This is an existing MULTIPOINT shapefile. \n"); 

      printf  (" You cannot add %s data to this file\n", argv[3]);

      exit ( 4); 
    }


    /* open the ascii coordinate file */

    ascii_ptr = fopen(argv[2],"r");
    if (ascii_ptr == NULL)
    {
	printf( "Unable to open coordinate file: %s\n", argv[2] );
	exit( 1 );
    }
 

/* -------------------------------------------------------------------- */
/*	Build a vertex/part list from the command line arguments.	*/
/* -------------------------------------------------------------------- */

    if( (padVertices = (double *) malloc(sizeof(double) * 1000 * 2)) == NULL )
    {
        printf( "Out of memory\n" );
        exit( 1 );
    }
    

    if( (panParts = (int *) malloc(sizeof(int) * 1000 )) == NULL )
    {
        printf( "Out of memory\n" );
        exit( 1 );
    }
    

    if (nShapeType ==  SHPT_POINT )
    {
        nParts = 1;
        panParts[0] = 0;

        eof = fgets( charcoord ,80, ascii_ptr); /*get first x,y pair */

        while ( strncmp(charcoord,"END",3) != 0 && eof != NULL)
        {
	     nVertices = 0;
             xx++;
/*           replace , with spaces */
             txtptr = strchr (charcoord, ',');
             if ( strcmp(txtptr ,NULL) != 0) txtptr[0] = ' ';
             txtptr = strchr (charcoord,',');
             if ( strcmp(txtptr ,NULL) != 0) txtptr[0] = ' ';
/*             printf ( "input %s  ", charcoord   );*/
             sscanf( charcoord,  "%d%lg%lg", &shapeId, padVertices+nVertices*2,
                                            padVertices+nVertices*2+1 );
 
             nVertices = 1;

             panParts[nParts] = nVertices;
   
/* -------------------------------------------------------------------- */
/*        Write the new entity to the shape file.                       */
/* -------------------------------------------------------------------- */

/*
printf( "%d %d %d \n", nVertices, nParts, panParts[0] );
printf ( "point1  %lg ",   padVertices[(nVertices-1)*2] );
printf ( "point2  %lg \n",   padVertices[(nVertices-1)*2+1] );
*/
            SHPWriteVertices(hSHP, nVertices, nParts, panParts, padVertices );

            eof = fgets( charcoord ,80,ascii_ptr); /*get line */
	}
    }
    else
    {
      eof = fgets( charcoord ,80, ascii_ptr); /*get first shapeId */
      sscanf( charcoord, "%ld", &shapeId );   /*get first shapeId */
      eof = fgets( charcoord ,80, ascii_ptr); /*get first x,y pair */

      while ( eof != NULL) 
      {  
        xx++;

        nVertices = 0;
        nParts = 1;
        panParts[0] = 0;

        while ( strncmp(charcoord,"END",3) != 0 && eof != NULL)
        {
          if (strncmp(charcoord,"BREAK",5)== 0 )/* start island or other poly*/
	  {
	      panParts[nParts++] = nVertices;
	  }
          else if ( strncmp(charcoord,"END",3) != 0  )
          { 
/*           replace , with spaces */
             txtptr = strchr (charcoord,',');
             if ( strcmp(txtptr ,NULL) != 0) txtptr[0] = ' ';

             sscanf( charcoord,  "%lg%lg",  padVertices+nVertices*2 ,
                                            padVertices+nVertices*2+1 );
 
/*
             printf ( "aout  %lg ",   padVertices[nVertices*2] );
             printf ( "bout  %lg \n",   padVertices[nVertices*2+1] );
*/
	     nVertices += 1;
	  }
          eof = fgets( charcoord ,80,ascii_ptr); /*get line */
        }
   
/* -------------------------------------------------------------------- */
/*      Write the new entity to the shape file.                         */
/* -------------------------------------------------------------------- */

/*
printf( "%d %d %d \n", nVertices, nParts, panParts[0] );
printf ( "arc2  %lg ",    padVertices[(nVertices-1)*2] );
printf ( "arc2  %lg \n",  padVertices[(nVertices-1)*2+1] );
*/

        SHPWriteVertices(hSHP, nVertices, nParts, panParts, padVertices );

        eof = fgets( charcoord ,80,ascii_ptr); /*get line */
        if ( strncmp(charcoord,"END",3) == 0  )
        {
          break ;
        }
        sscanf(charcoord , "%ld", &shapeId ); /*get next shapeId */
        eof = fgets( charcoord ,80,ascii_ptr); /*get line */
      } 

    }

    printf (" %d shapes where added to shapefile %s\n",xx,argv[1]);
    SHPGetInfo( hSHP, &nEntities, &nShapeType );
    printf (" There are now %d shapes in the shapefile \n",nEntities);
    SHPClose( hSHP );

    free( panParts );
    free( padVertices );
}
