/*
 * shp2dxf  - shape export to dxf
 * modified the original shpdump to produce a dxf file
 * sol katz Nov 1997, skatz@blm.gov
  *
 */


#include "shapefil.h"
#include <stdlib.h>  /* pc dos */ 

int main( int argc, char ** argv )

{
    SHPHandle	hSHP;
    int		nShapeType, nEntities, nVertices, nParts, *panParts, i, iPart;
    double	*padVertices, adBounds[4];
    const char 	*pszPlus;

/* -------------------------------------------------------------------- */
/*      Display a usage message.                                        */
/* -------------------------------------------------------------------- */
    if( argc != 2 )
    {
	printf( "shp2dxf shp_file\n" );
        printf( "shape to dxf, another GIS translation tool by\n");
        printf( "Sol Katz,skatz@blm.gov, 303-236-0101, Nov 1997\n");
	exit( 1 );
    }

/* -------------------------------------------------------------------- */
/*      Open the passed shapefile.                                      */
/* -------------------------------------------------------------------- */
    hSHP = SHPOpen( argv[1], "rb" );

    if( hSHP == NULL )
    {
	printf( "Unable to open:%s\n", argv[1] );
	exit( 1 );
    }

    SHPGetInfo( hSHP, &nEntities, &nShapeType );

  printf ( "0\n" );
  printf ( "SECTION\n" );
  printf ( "2\n" );
  printf ( "ENTITIES\n" );
/* -------------------------------------------------------------------- */
/*	Skim over the list of shapes, printing all the vertices.	*/
/* -------------------------------------------------------------------- */
    for( i = 0; i < nEntities; i++ )
    {
	int		j;

	padVertices = SHPReadVertices( hSHP, i, &nVertices, &nParts,
				       &panParts );

        if (nShapeType ==  SHPT_POINT )
        {
	  {
  	/*     printf( "point %d, ", i+1  ); */
	    if( iPart < nParts && panParts[iPart] == j+1 )
	    {
		iPart++;
		pszPlus = "+";
	    }
	    else
	        pszPlus = "";

            if (strcmp(pszPlus, "+")==0) 
            {
		  j = 0;
		  printf ( "0\n" );
		  printf ( "POINT\n" );
		  printf ( "8\n" );
		  printf ( "1\n ");   /* layer */
		  printf ( "10\n" );
		  printf ( "%lg\n", padVertices[j*2]  );
		  printf ( "20\n" );
		  printf ( "%lg\n", padVertices[j*2+1]); 
            }
            else
            {
	
	    for( j = 0, iPart = 1; j < nVertices; j++ )
		  printf ( "0\n" );
		  printf ( "POINT\n" );
		  printf ( "8\n" );
		  printf ( "1\n ");    /* layer */
		  printf ( "10\n" );
		  printf ( "%lg\n", padVertices[j*2]  );
		  printf ( "20\n" );
		  printf ( "%lg\n", padVertices[j*2+1]); 
            }
	  }
        }
        else
        {
	  printf ( "0\n" );
	  printf ( "POLYLINE\n" );
	  printf ( "8\n" );
	  printf ( "1\n ");  /* layer */
	  printf ( "66\n" );
	  printf ( "1\n" );

	/*  printf( "arc %d \n", i+1  ); */

	  for( j = 0, iPart = 1; j < nVertices; j++ )
	  {
	    if( iPart < nParts && panParts[iPart] == j+1 )
	    {
		iPart++;
		pszPlus = "+";
	    }
	    else
	        pszPlus = "";

            if (strcmp(pszPlus, "+")==0) 
            {
	         printf("%lg, %lg\nBREAK\n", 
		 padVertices[j*2], padVertices[j*2+1]) ;
            }
            else
            {
		 printf ( "0\n" );
		 printf ( "VERTEX\n" );
		 printf ( "8\n" );
	 	 printf ( "1\n");    /* layer */
		 printf ( "10\n" );
		 printf ( "%lg\n", padVertices[j*2]);
		 printf ( "20\n" );
		 printf ( "%lg\n",padVertices[j*2+1]); 
/*
	         printf("%lg, %lg\n", 
		 padVertices[j*2], padVertices[j*2+1]); 
*/
            }
	  }
	  /* feature end */
	  printf ( "0\n" );
	  printf ( "SEQEND\n" );
 	  printf ( "8\n" );
	  printf ( "1\n");     /* layer */
	}
    }
    printf ("0\n" );
    printf ("ENDSEC\n" );
    printf ("0\n" );
    printf ("EOF\n" ); 
    SHPClose( hSHP );
}
