/*
 * shp2gen  - shape export
 * modified the original shpdump to produce a arc generate file
 * sol katz Oct 1997, skatz@blm.gov
  *
 */


#include "shapefil.h"
#include <stdlib.h>  /* pc dos */ 

int main( int argc, char ** argv )

{
    SHPHandle	hSHP;
    int		nShapeType, nEntities, nVertices, nParts, *panParts, i, iPart;
    double	*padVertices, adBounds[4];
/*    const */ char 	*pszPlus;

/* -------------------------------------------------------------------- */
/*      Display a usage message.                                        */
/* -------------------------------------------------------------------- */
    if( argc != 2 )
    {
	printf( "shp2gen shp_file\n" );
        printf( "shape to generate export, another GIS translation tool by\n");
        printf( "Sol Katz,skatz@blm.gov, 303-236-0101, Oct 1997\n");
	exit( 1 );
    }

/* -------------------------------------------------------------------- */
/*      Open the passed shapefile.                                      */
/* -------------------------------------------------------------------- */
    hSHP = SHPOpen( argv[1], "rb" );

    if( hSHP == NULL )
    {
	printf( "Unable to open:%s\n", argv[1] );
	exit( 1 );
    }

    SHPGetInfo( hSHP, &nEntities, &nShapeType );

/* -------------------------------------------------------------------- */
/*	Skim over the list of shapes, printing all the vertices.	*/
/* -------------------------------------------------------------------- */
    for( i = 0; i < nEntities; i++ )
    {
	int		j;

	padVertices = SHPReadVertices( hSHP, i, &nVertices, &nParts,
				       &panParts );

        if (nShapeType ==  SHPT_POINT )
        {
	  for( j = 0, iPart = 1; j < nVertices; j++ )
	  {
  	     printf( "%d, ", i+1  );
	    if( iPart < nParts && panParts[iPart] == j+1 )
	    {
		iPart++;
		pszPlus = "+";
	    }
	    else
	        pszPlus = "";

            if (strcmp(pszPlus, "+")==0) 
            {
	         printf("%lg, %lg\nBREAK\n", 
		 padVertices[j*2], padVertices[j*2+1]) ;
            }
            else
            {
	
	         printf("%lg, %lg\n", 
		 padVertices[j*2], padVertices[j*2+1]); 
            }
	  }
        }
        else
        {
	  printf( "%d \n", i+1  );

	  for( j = 0, iPart = 1; j < nVertices; j++ )
	  {
	    if( iPart < nParts && panParts[iPart] == j+1 )
	    {
		iPart++;
		pszPlus = "+";
	    }
	    else
	        pszPlus = "";

            if (strcmp(pszPlus, "+")==0) 
            {
	         printf("%lg, %lg\nBREAK\n", 
		 padVertices[j*2], padVertices[j*2+1]) ;
            }
            else
            {
	
	         printf("%lg, %lg\n", 
		 padVertices[j*2], padVertices[j*2+1]); 
            }
	  }
          printf ("END\n"); /* feature end */
	}
    }
    printf ("END\n"); /* final end */
    SHPClose( hSHP );
}
