/* Written by Bill Brown, UIUC GIS Laboratory
 */

#include "gis.h"

struct Cell_head    Wind;

main(argc, argv)
    int argc;
    char *argv[];
{

    struct Option 	*in;
    struct Flag 	*shh, *inreg;
    char 		errbuf[100];
    char                *sitesmap;
    struct Cell_head    w;


    G_gisinit (argv[0]);

    in = G_define_option();
    in->key                    = "sites";
    in->type                   = TYPE_STRING;
    in->required               = YES;
    in->gisprompt    	       = "old,site_lists,sites";
    in->description            = "Name of sites file.";

    shh = G_define_flag ();
    shh->key = 'q';
    shh->description = "Load quietly";

    inreg = G_define_flag ();
    inreg->key = 'w';
    inreg->description = "Only count sites in current window for min/max.";

    if (G_parser (argc, argv))
	exit (-1);

    sitesmap = G_find_file2 ("site_lists", in->answer, "");
    if(!sitesmap){
	sprintf(errbuf,"Couldn't find sites file %s", in->answer);
	G_fatal_error(errbuf);
    }

    G_get_set_window (&Wind);
    
    set_quiet(shh->answer);
    do_new_sites(in->answer,sitesmap,inreg->answer);
    sites_describe();
    if(inreg->answer)
	fprintf(stderr,
	   "NOTE: min/max values are only for sites in current region!\n");

    return(1);

}



