.TH s.normal
.SH NAME
\fIs.normal\fR \- tests for normality for sites.
.br
.I (GRASS Sites Program)
.SH SYNOPSIS
\fBs.normal\fR
.br
\fBs.normal help\fR
.br
\fBs.normal \fR[\fB-q\fR] \fBinput\*=name\fR 
[\fBtests\*=\fIrange\fR[,\fIrange\fR,...]]
.SH DESCRIPTION
.I s.normal
computes tests of normality on floating point attributes of a site list.
.SH OPTIONS
\fBFlag:\fR
.IP \fB-q\fR 18
Quiet. Cut out the chatter when reading site list.
.LP
\fBParameters:\fR
.IP \fBinput\*=\fIname\fR 18
Name of sites list.
.IP \fBtests\*=\fIrange\fR[,\fIrange\fR,...]] 18
Tests of normality requested (see below).
.SH NOTES
The tests that
.I s.normal
performs are indexed below.
The tests that are performed are 
specified by giving an index, ranges
of indices, or multiple thereof. 
.LP
.IP \fB1\fR 6
Sample skewness and kurtosis
.IP \fB2\fR 6
Geary's a-statistic and an approximate normal transformation
.IP \fB3\fR 6
Extreme normal deviates
.IP \fB4\fR 6
D'Agostino's D-statistic 
.IP \fB5\fR 6
Modified Kuiper V-statistic 
.IP \fB6\fR 6
Modified Watson U^2-statistic 
.IP \fB7\fR 6
Durbin's Exact Test (modified Kolmogorov)
.IP \fB8\fR 6
Modified Anderson-Darling statistic 
.IP \fB9\fR 6
Modified Cramer-Von Mises W^2-statistic 
.IP \fB10\fR 6
Kolmogorov-Smirnov D-statistic (modified for normality testing)
.IP \fB11\fR 6
Chi-Square test statistic (equal probability classes) and 
the number of degrees of freedom
.IP \fB12\fR 6
Shapiro-Wilk W Test
.IP \fB13\fR 6
Weisberg-Binghams W'' (similar to Shapiro-Francia's W')
.IP \fB14\fR 6
Royston's extension of W for large samples
.IP \fB15\fR 6
Kotz Separate-Families Test for Lognormality vs. Normality
.SH EXAMPLE
\fBs.normal input\*=soils tests\*=1-3,14\fR
.LP
.RS
computes the
sample skewness and kurtosis,
Geary's a-statistic and an approximate normal transformation,
extreme normal deviates, and Royston's W 
for the \fIsoils\fR site list.
.RE
.SH SEE ALSO
.I s.univar
and
\fIGoodness of Fit Techniques\fR \- 
GRASS Tutorial on libcdhc.a
(available as libcdhc-tutorial.ps)
.SH BUGS
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Agricultural and Biological Engineering, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
