.TH s.perturb
.SH NAME
\fIs.perturb\fR \- Random location perturbations of GRASS sites.
.br
.I (GRASS Sites Program)
.SH SYNOPSIS
\fBs.perturb\fR
.br
\fBs.perturb help\fR
.br
\fBs.perturb\fR [\fB-q\fR] \fBinput\*=\fIname\fR  
\fBoutput\*=\fIname\fR 
\fBdistribution\*=\fR[\fIuniform\fR|\fInormal\fR]
\fBparameters\*=\fIvalue,\fR[\fIvalue\fR]
.SH DESCRIPTION
.I s.perturb
reads a site list and writes the same list but
\fIperturbs\fR the eastings and northings by
adding either a uniform or normal delta value.
.SH OPTIONS
\fBFlag:\fR
.IP \fB-q\fR 18
Quiet. Cut out the chatter.
.LP
\fBParameters:\fR
.IP \fBinput\*=\fIname\fR 18
Name of an existing sites file.
.LP
.IP \fBoutput\*=\fIname\fR 18
Name of output sites file.
.LP
.IP \fBdistribution\*=\fR[\fIuniform\fR|\fInormal\fR] 18
Distribution of perturbation.
.LP
.IP \fBparameters\*=\fIvalue\fR[\fI,value\fR] 18
Parameter(s) of distribution. If the distribution
is uniform, only one parameter, the maximum, is needed.
For a normal distribution, two parameters, the mean and
standard deviation, are required.
.SH NOTES
The uniform distribution is always centered about zero.
The associated parameter is constrained to be positive
and specifies the maximum of the 
distribution; the minimum is the negation of that parameter.
.LP
Usually, the mean (first parameter) of the normal distribution
is zero (i.e., the distribution is centered at zero). The
standard deviation (second parameter) is naturally constrained to be
positive.
.LP
Output sites are not guaranteed to be contained within the current
geographic region.
.SH SEE ALSO
.I g.region,
.I s.rand,
.I s.univar,
and
.I s.kcv,
.SH BUGS
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Agricultural Engineering, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
.LP
Random number generators originally written in FORTRAN
by Wes Peterson (wpp@ips.ethz.ch) and are
available from netlib.att.com:netlib/random/zufall.Z.
They were translated to C using \fIf2cfR.
