.TH s.probplot
.SH NAME
\fIs.probplot\fR \- Normal probability plot of a GRASS site list.
.br
.I (GRASS Sites Program)
.SH SYNOPSIS
\fBs.probplot\fR
.br
\fBs.probplot help\fR
.br
\fBs.probplot \fR[\fB-alq\fR] \fBsites\*=\fIname\fR
\fBwidth\*=\fIvalue\fR [\fBgraph\*=\fIname\fR]
.SH DESCRIPTION
.I s.probplot
does normal or lognormal probability plots of floating point
attributes in a site list.
.SH OPTIONS
\fBFlags:\fR
.IP \fB-a\fR 18
Use all sites found in the named \fIsites\fR file, rather than
limiting output to sites falling within the current geographic region.
.IP \fB-l\fR 18
Lognormal probability plot instead of normal.
.IP \fB-q\fR 18
Quiet. Cut out the chatter.
.LP
\fBParameters:\fR
.IP \fBsites\*=\fIname\fR 18
Name of an existing sites file.
.IP \fBwidth\*=\fIvalue\fR 18
Width of bins.
.IP \fBgraph\*=\fIname\fR 18
Basename to save graphing data/commands files.
Graphs are saved in the current working directory with
the extensions \fI.gp\fR and \fI.dat\fR
.SH EXAMPLE
Given a sites file named \fIexample\fR in the following format:
.LP
.RS
83.8|92.2|3.5689
.br
83.8|82.2|3.9269
.br
83.8|80.2|3.5389
.br
83.8|69.2|3.7452
.RE
.LP
Suppose that we wish to examine normality of the site values (third column).
The first step is to examine minimum and maximum and determine with
the histogram bin width using \fBs.univar\fR:
.LP
.RS
\fBs.univar -gq sites\*=example\fR
.RE
.LP
This command outputs:
.LP
.RS
n=216
.br
min=1.489
.br
max=3.9419
.RE
.LP
along with other useful statistics. For this range and number of 
observations, we randomly select 0.1 as the histogram bin width.
Then, the following command graphs a probability plot in the
GRASS graphics window and saves it in the current working
directory with a basename of \fImyplot\fR:
.LP
.RS
\fBs.probplt -q sites=example width=0.1 graph=myplot\fR
.RE
.LP
To view the graph again, try 
.LP
.RS
\fBg.gnuplot myplot.gp
.RE
.LP
Using \fIg.gnuplot\fR, the graphs may be output as 
PostScript, LaTeX, FrameMaker MIF, or many other formats.
.SH SEE ALSO
.I s.univar,
.I s.normal,
and
.I http://www.cs.dartmouth.edu/gnuplot_info.html
.SH BUGS
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Agricultural and Biological Engineering, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
