#include "gis.h"
#include "s_struct.h"
#include "quaddefs.h"

int readsites (fdsite, verbose, xyd, window)
  FILE *fdsite;
  int verbose;
  Z **xyd;
  struct Cell_head window;
{
  char *dum;
  int i, alloced = 1000;
  Site *s;
  /* should be in gis.h but aren't */
  int G_sleep_on_error(), G_fatal_error(), G_get_site(), G_percent();

  G_sleep_on_error (0);

  s = G_site_new_struct (-1, 2, 0, 0);

  if (verbose)
    fprintf (stderr, "Reading sites list ...              ");

  /* allocate chunk of memory */
#ifndef lint
  (*xyd) = (Z *) G_malloc (alloced * sizeof (Z));
#endif
  if ((*xyd) == NULL)
    G_fatal_error ("cannot allocate memory for input sites list");
  i = 0;
  while (G_site_get (fdsite, s) == 0)
  {
    if (s->east >= window.west && s->east <= window.east &&
	s->north <= window.north && s->north >= window.south)
    {
      if (i == alloced)
      {
	alloced += 1000;
#ifndef lint
	(*xyd) = (Z *) G_realloc (alloced * sizeof (Z));
#endif
	if ((*xyd) == NULL)
          G_fatal_error ("cannot allocate memory for input sites list");
      }
      (*xyd)[i].x = s->east;
      (*xyd)[i++].y = s->north;
    }
  }
  fclose (fdsite);
  G_sleep_on_error (1);
  if (verbose)
    G_percent (1, 1, 1);
  return i;
}
