.TH s.qcount
.SH NAME
\fIs.qcount\fR \- indices for quadrat counts of sites lists
.br
.I (GRASS Sites Program)
.SH SYNOPSIS
\fBs.qcount\fR
.br
\fBs.qcount help\fR
.br
\fBs.qcount\fR [\fB-ciq\fR] \fBinput\*=\fIname\fR 
\fBn\*=\fIvalue\fR \fBr\*=\fIvalue\fR 
.SH DESCRIPTION
.I s.qcount
chooses \fBn\fR circular quadrats of radius \fBr\fR such that they
are completely within the bounds of the current region and no two
quadrats overlap. The number of sites falling within each 
quadrat are counted and indices are calculated to estimate 
the departure of site locations from complete spatial 
randomness.
.SH OPTIONS
\fBFlags:\fR
.IP \fB-c\fR 18
Print count data for each quadrat in the form of a sites list
(E|N|#n desc, where E is the easting and N is the northing of 
the quadrat center, n is the quadrat number, and desc is an
integer indicating the number of sites contained within the quadrat).
.IP \fB-i\fR 18
Suppress printing table of indices (default is to print indices 
and not the count data).
.IP \fB-q\fR 18
Quiet. Cut out the chatter.
.LP
\fBParameters:\fR
.IP \fBinput\*=\fIname\fR 18
Name of sites list defining qcount points.
.LP
.IP \fBn\*=\fIvalue\fR 18
Number of quadrats (integer).
.LP
.IP \fBr\*=\fIvalue\fR 18
Radius of quadrats (floating point).
.SH NOTES
.LP
This program may not work properly with lat-long data. It uses 
\fIhypot()\fR
in two files: \fIcount.c\fR and \fIfindquads.c\fR.
.LP
.SH SEE ALSO
.I s.rand
and
.br
\fIComplete Spatial Randomness and Quadrat Methods\fR \- 
GRASS Tutorial on \fIs.qcount\fR
(available as s.qcount-tutorial.ps),
.LP
General references include:
.br
Noel A. C. Cressie.
\fIStatistics for Spatial Data\fR.
Wiley Series in Probability and Mathematical Statistics. John Wiley
& Sons, New York, NY, 1st edition, 1991.
.br
Brian D. Ripley.
\fISpatial Statistics\fR.
John Wiley \& Sons, New York, NY, 1981.
.LP
References to the indices include:
.br
F. N. David and P. G. Moore.
Notes on contagious distributions in plant populations.
\fIAnnals of Botany\fR, 
18:47-53, 1954.
.br
J. B. Douglas.  Clustering and aggregation.
\fISankhya B\fR, 
37:398-417, 1975.
.br
R. A. Fisher, H. G. Thornton, and W. A. Mackenzie.
The accuracy of the plating method of estimating the density of
bacterial populations.
\fIAnnals of Applied Biology\fR, 
9:325-359, 1922.
.br
M. Lloyd.
Mean crowding.
\fIJournal of Animal Ecology\fR, 
36:1-30, 1967.
.br
M. Morista.
Measuring the dispersion and analysis of distribution patterns.
\fIMemoires of the Faculty of Science, Kyushu University, Series E.
Biology\fR, 2:215-235, 1959.
.SH BUGS
Please send all bug fixes and comments to the author.
.SH AUTHOR
James Darrell McCauley, Agricultural Engineering, Purdue University 
.if n .br 
(mccauley@ecn.purdue.edu)
